/**
 *
 * @param {TemplateStringsArray} strings
 * @param  {any[]} values
 * @returns {Node[]}
 */
export function b(strings: TemplateStringsArray, ...values: any[]): import("estree").Node[];
/**
 *
 * @param {TemplateStringsArray} strings
 * @param  {any[]} values
 * @returns {Expression & { start: Number, end: number }}
 */
export function x(strings: TemplateStringsArray, ...values: any[]): (import("estree").Identifier & {
    start: number;
    end: number;
}) | (import("estree").SimpleLiteral & {
    start: number;
    end: number;
}) | (import("estree").RegExpLiteral & {
    start: number;
    end: number;
}) | (import("estree").BigIntLiteral & {
    start: number;
    end: number;
}) | (import("estree").FunctionExpression & {
    start: number;
    end: number;
}) | (import("estree").ArrowFunctionExpression & {
    start: number;
    end: number;
}) | (import("estree").ThisExpression & {
    start: number;
    end: number;
}) | (import("estree").ArrayExpression & {
    start: number;
    end: number;
}) | (import("estree").ObjectExpression & {
    start: number;
    end: number;
}) | (import("estree").YieldExpression & {
    start: number;
    end: number;
}) | (import("estree").UnaryExpression & {
    start: number;
    end: number;
}) | (import("estree").UpdateExpression & {
    start: number;
    end: number;
}) | (import("estree").BinaryExpression & {
    start: number;
    end: number;
}) | (import("estree").AssignmentExpression & {
    start: number;
    end: number;
}) | (import("estree").LogicalExpression & {
    start: number;
    end: number;
}) | (import("estree").MemberExpression & {
    start: number;
    end: number;
}) | (import("estree").ConditionalExpression & {
    start: number;
    end: number;
}) | (import("estree").SimpleCallExpression & {
    start: number;
    end: number;
}) | (import("estree").NewExpression & {
    start: number;
    end: number;
}) | (import("estree").SequenceExpression & {
    start: number;
    end: number;
}) | (import("estree").TemplateLiteral & {
    start: number;
    end: number;
}) | (import("estree").TaggedTemplateExpression & {
    start: number;
    end: number;
}) | (import("estree").ClassExpression & {
    start: number;
    end: number;
}) | (import("estree").MetaProperty & {
    start: number;
    end: number;
}) | (import("estree").AwaitExpression & {
    start: number;
    end: number;
}) | (import("estree").ImportExpression & {
    start: number;
    end: number;
}) | (import("estree").ChainExpression & {
    start: number;
    end: number;
});
/**
 *
 * @param {TemplateStringsArray} strings
 * @param  {any[]} values
 * @returns {(Property | SpreadElement) & { start: Number, end: number }}
 */
export function p(strings: TemplateStringsArray, ...values: any[]): (import("estree").Property & {
    start: number;
    end: number;
}) | (import("estree").SpreadElement & {
    start: number;
    end: number;
});
export { print } from "./print/index.js";
export function parse(source: string, opts: any): any;
export function parseExpressionAt(source: string, index: number, opts: any): any;
export type Expression = import("estree").Identifier | import("estree").SimpleLiteral | import("estree").RegExpLiteral | import("estree").BigIntLiteral | import("estree").FunctionExpression | import("estree").ArrowFunctionExpression | import("estree").ThisExpression | import("estree").ArrayExpression | import("estree").ObjectExpression | import("estree").YieldExpression | import("estree").UnaryExpression | import("estree").UpdateExpression | import("estree").BinaryExpression | import("estree").AssignmentExpression | import("estree").LogicalExpression | import("estree").MemberExpression | import("estree").ConditionalExpression | import("estree").SimpleCallExpression | import("estree").NewExpression | import("estree").SequenceExpression | import("estree").TemplateLiteral | import("estree").TaggedTemplateExpression | import("estree").ClassExpression | import("estree").MetaProperty | import("estree").AwaitExpression | import("estree").ImportExpression | import("estree").ChainExpression;
export type Node = import("estree").Identifier | import("estree").SimpleLiteral | import("estree").RegExpLiteral | import("estree").BigIntLiteral | import("estree").Program | import("estree").FunctionDeclaration | import("estree").FunctionExpression | import("estree").ArrowFunctionExpression | import("estree").SwitchCase | import("estree").CatchClause | import("estree").VariableDeclarator | import("estree").ExpressionStatement | import("estree").BlockStatement | import("estree").EmptyStatement | import("estree").DebuggerStatement | import("estree").WithStatement | import("estree").ReturnStatement | import("estree").LabeledStatement | import("estree").BreakStatement | import("estree").ContinueStatement | import("estree").IfStatement | import("estree").SwitchStatement | import("estree").ThrowStatement | import("estree").TryStatement | import("estree").WhileStatement | import("estree").DoWhileStatement | import("estree").ForStatement | import("estree").ForInStatement | import("estree").ForOfStatement | import("estree").VariableDeclaration | import("estree").ClassDeclaration | import("estree").ThisExpression | import("estree").ArrayExpression | import("estree").ObjectExpression | import("estree").YieldExpression | import("estree").UnaryExpression | import("estree").UpdateExpression | import("estree").BinaryExpression | import("estree").AssignmentExpression | import("estree").LogicalExpression | import("estree").MemberExpression | import("estree").ConditionalExpression | import("estree").SimpleCallExpression | import("estree").NewExpression | import("estree").SequenceExpression | import("estree").TemplateLiteral | import("estree").TaggedTemplateExpression | import("estree").ClassExpression | import("estree").MetaProperty | import("estree").AwaitExpression | import("estree").ImportExpression | import("estree").ChainExpression | import("estree").PrivateIdentifier | import("estree").Property | import("estree").PropertyDefinition | import("estree").AssignmentProperty | import("estree").Super | import("estree").TemplateElement | import("estree").SpreadElement | import("estree").ObjectPattern | import("estree").ArrayPattern | import("estree").RestElement | import("estree").AssignmentPattern | import("estree").ClassBody | import("estree").MethodDefinition | import("estree").ImportDeclaration | import("estree").ExportNamedDeclaration | import("estree").ExportDefaultDeclaration | import("estree").ExportAllDeclaration | import("estree").ImportSpecifier | import("estree").ImportDefaultSpecifier | import("estree").ImportNamespaceSpecifier | import("estree").ExportSpecifier;
export type ObjectExpression = import("estree").ObjectExpression;
export type Property = import("estree").Property;
export type SpreadElement = import("estree").SpreadElement;
export type CommentWithLocation = import("estree").Comment & {
    start: number;
    end: number;
    has_trailing_newline?: boolean;
};
